From 03dca701619a0d4b2018eba6afaf0aa245cec077 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:18 +0000
Subject: [PATCH 453/2232] Fix Vec returns by value


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index cda77db..35603c9 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -296,6 +296,7 @@ fn expand_cxx_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types
         efn.ret.as_ref().and_then(|ret| match ret {
             Type::Ident(ident) if ident == RustString => Some(quote!(#call.into_string())),
             Type::RustBox(_) => Some(quote!(::std::boxed::Box::from_raw(#call))),
+            Type::RustVec(_) => Some(quote!(#call.into_vec())),
             Type::UniquePtr(_) => Some(quote!(::cxx::UniquePtr::from_raw(#call))),
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(ident) if ident == RustString => Some(quote!(#call.as_string())),
diff --git a/syntax/types.rs b/syntax/types.rs
index 2ef1e1e..f3aaa16 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -96,6 +96,7 @@ impl<'a> Types<'a> {
                     Atom::from(ident) == Some(RustString)
                 }
             }
+            Type::RustVec(_) => true,
             _ => false,
         }
     }

